// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2008                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : N.Kubo
//    : 2008/01/10 
//
//-------------------------------------------------------------------

// GrayFilterDlg.cpp : t@C
//

#include "stdafx.h"
#include "GrayFilter.h"
#include "GrayFilterDlg.h"
#include "LicenceDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CGrayFilterDlg _CAO




CGrayFilterDlg::CGrayFilterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGrayFilterDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGrayFilterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CGrayFilterDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_LOADIMAGE, &CGrayFilterDlg::OnBnClickedLoadimage)
	ON_BN_CLICKED(IDC_GRAB, &CGrayFilterDlg::OnBnClickedGrab)
	ON_BN_CLICKED(IDC_AVERAGING, &CGrayFilterDlg::OnBnClickedAveraging)
	ON_BN_CLICKED(IDC_LAPLACIAN, &CGrayFilterDlg::OnBnClickedLaplacian)
	ON_BN_CLICKED(IDC_MINFILTER, &CGrayFilterDlg::OnBnClickedMinfilter)
	ON_BN_CLICKED(IDC_MAXFILTER, &CGrayFilterDlg::OnBnClickedMaxfilter)
	ON_BN_CLICKED(IDC_MIN4FILTER, &CGrayFilterDlg::OnBnClickedMin4filter)
	ON_BN_CLICKED(IDC_MAX4FILTER, &CGrayFilterDlg::OnBnClickedMax4filter)
	ON_BN_CLICKED(IDC_MEDIAN, &CGrayFilterDlg::OnBnClickedMedian)
	ON_BN_CLICKED(IDC_SHARP, &CGrayFilterDlg::OnBnClickedSharp)
	ON_BN_CLICKED(IDC_SOBEL, &CGrayFilterDlg::OnBnClickedSobel)
	ON_BN_CLICKED(IDC_ROBERTS, &CGrayFilterDlg::OnBnClickedRoberts)
	ON_BN_CLICKED(IDC_FDEFFERENTIAL, &CGrayFilterDlg::OnBnClickedFdefferential)
	ON_BN_CLICKED(IDC_SDEFFERENTIAL, &CGrayFilterDlg::OnBnClickedSdefferential)
	ON_BN_CLICKED(IDC_ZEROCROSS, &CGrayFilterDlg::OnBnClickedZerocross)
	ON_BN_CLICKED(IDC_ANYCROSS, &CGrayFilterDlg::OnBnClickedAnycross)
	ON_BN_CLICKED(IDC_EXEREGION, &CGrayFilterDlg::OnBnClickedExeregion)
	ON_BN_CLICKED(IDC_SAVEIMAGE, &CGrayFilterDlg::OnBnClickedSaveimage)
	ON_WM_SIZE()
END_MESSAGE_MAP()


// CGrayFilterDlg bZ[W nh

BOOL CGrayFilterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B
	CLicenceDlg dlg;
	if (dlg.DoModal() == IDOK){
	
		//Ӂ
		// COM̏KsĂB
		CoInitialize( NULL ); 
		CWnd *pwnd; 
		IUnknown *p_unknown;
		

		pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
		p_unknown = pwnd->GetControlUnknown();
		p_unknown->QueryInterface( __uuidof(IFvxDisplayExPtr), (void**)&m_FvxDisplayEx ); 
		
		// eFvxRg[̃CX^X𐶐

		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxImage1.CreateInstance( __uuidof( FvxImage ) );
		m_FvxImage2.CreateInstance( __uuidof( FvxImage ) );
		m_FvxFileAccess.CreateInstance(__uuidof(FvxFileAccess));
		m_FvxGrayFilter.CreateInstance(__uuidof(FvxGrayFilter));
		m_FvxROI.CreateInstance( __uuidof( FvxROI) );

		m_FvRectangle.CreateInstance( __uuidof( FvRectangle ) ); 

		m_blnVideoOpened = false;

		m_FvxVideo->PutVideoConfFile(L"");
		m_FvxVideo->ShowPropertyPage();
		size_t nLen = m_FvxVideo->GetVideoConfFile().length();

		 
		if( nLen != 0 ) 	{
			m_FvxVideo->OpenDevice();
			Sleep(350);
			m_FvxVideo->ChangeImageSize(m_FvxImage1);
			m_FvxVideo->SetTrigger(1);
			((CButton*)GetDlgItem(IDC_GRAB))->EnableWindow(TRUE);
			m_blnVideoOpened = true;
		}
		else
			((CButton*)GetDlgItem(IDC_GRAB))->EnableWindow(FALSE);
			

		m_FvxDisplayEx->CreateDisplay(3,0);

		// ͈͂̏lݒi摜̑Oʂɐݒj
		m_FvRectangle->Putxs( -1 );
		m_FvRectangle->Putxe( -1 );
		m_FvRectangle->Putys( -1 );
		m_FvRectangle->Putye( -1 );

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}
	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CGrayFilterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CGrayFilterDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CGrayFilterDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CGrayFilterDlg::OnBnClickedLoadimage()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CFileDialog Dlg( TRUE, _T("bmp"), _T("*.bmp"), OFN_FILEMUSTEXIST, _T("Bmpt@C(*.bmp)|*.bmp|S(*.*)|*.*||"));
	CString strPtnName;

	if (IDOK == Dlg.DoModal())
	{
		m_FvxFileAccess->PutFilePath ( _bstr_t( Dlg.GetPathName() ));
		try
		{
			m_FvxFileAccess->LoadBitmap( m_FvxImage1);
		} catch (long &err) {
			m_FvxFileAccess->GetErrReport(&err);
			CString errMsg;
			errMsg = _T("Ǎ݂Ɏs܂BErrCode= %ld"),err;
			::AfxMessageBox( errMsg);

			return;
		}

		// 摜`FbN
		if (( m_FvxImage1->BitPerPixel!=8 ) || ( m_FvxImage1->ImageType!=imageGray ))
		{
			AfxMessageBox(_T("8bitO[摜ł͂܂"));

			m_FvxImage1->BitPerPixel = 8;
			m_FvxImage1->ImageType = imageGray;
			m_FvxImage1->ImageWidth = 512;
			m_FvxImage1->ImageHeight = 480;
		}

		m_FvxDisplayEx->DrawImage(m_FvxImage1);
	}
}



void CGrayFilterDlg::OnBnClickedGrab()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	// 摜t@Cǂݍ݂ɂāA摜TCY
    // ύXĂ\邽߁AChangeImageSizes܂B
    // 摜TCYύX\ꍇ́AɈxsΖL܂
	long error_code;
	m_FvxVideo->ChangeImageSize(m_FvxImage1);
	
	CString error_string;

	try{
		m_FvxVideo->GrabSync( m_FvxImage1 );
	}
	catch(_com_error){
		m_FvxVideo->GetErrReport(&error_code);
		error_string.Format(_T("rfI̎捞Ɏs܂ErrCode= %ld"),error_code);
		::AfxMessageBox(error_string);
	}

}

// ωtB^
void CGrayFilterDlg::OnBnClickedAveraging()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	m_FvxImage1->CopyTo(m_FvxImage2);

	//tB^s
    m_FvxGrayFilter->Averaging( m_FvxImage1, m_FvxImage2 );
   
    // ωɑĕʂ̏ł悤ɁÃC[WɃRs[Ă܂B
    // ÃRs[sƉ摜̗L͈͂ZbgĂ܂܂B
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
   	
}

// vVAtB^
void CGrayFilterDlg::OnBnClickedLaplacian()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->Laplacian( m_FvxImage1, m_FvxImage2 );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// ߖTŏltB^
void CGrayFilterDlg::OnBnClickedMinfilter()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->MinFilter( m_FvxImage1, m_FvxImage2 );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// ߖTőltB^
void CGrayFilterDlg::OnBnClickedMaxfilter()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->MaxFilter( m_FvxImage1, m_FvxImage2 );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}


// SߖTŏltB^
void CGrayFilterDlg::OnBnClickedMin4filter()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->Min4Filter( m_FvxImage1, m_FvxImage2, ALL_MODE );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

void CGrayFilterDlg::OnBnClickedMax4filter()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->Max4Filter( m_FvxImage1, m_FvxImage2, ALL_MODE );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// fBAtB^
void CGrayFilterDlg::OnBnClickedMedian()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->Median( m_FvxImage1, m_FvxImage2 );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

void CGrayFilterDlg::OnBnClickedSharp()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->Sharp( m_FvxImage1, m_FvxImage2 );
    m_FvxImage2->CopyTo( m_FvxImage1 );    
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// NstB^
void CGrayFilterDlg::OnBnClickedSobel()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->Sobel( m_FvxImage1, m_FvxImage2, (DIRECTION_TYPE )2 );
    m_FvxImage2->CopyTo( m_FvxImage1 );    
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );

}

// o[ctB^
void CGrayFilterDlg::OnBnClickedRoberts()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->Roberts( m_FvxImage1, m_FvxImage2 );
    m_FvxImage2->CopyTo( m_FvxImage1 );    
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}



// ꎟ
void CGrayFilterDlg::OnBnClickedFdefferential()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->Fdefferential( m_FvxImage1, m_FvxImage2, (DIRECTION_TYPE )2 );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// QtB^
void CGrayFilterDlg::OnBnClickedSdefferential()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->Sdefferential( m_FvxImage1, m_FvxImage2 );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// [NXtB^
void CGrayFilterDlg::OnBnClickedZerocross()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->ZeroCross( m_FvxImage1, m_FvxImage2, 8, 255 );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// CӈʒuNbVO
void CGrayFilterDlg::OnBnClickedAnycross()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->AnyCross( m_FvxImage1, m_FvxImage2, 8, 128, 255 );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

void CGrayFilterDlg::OnBnClickedExeregion()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	long lngOK = 0;
	double dblTemp = 0;
	
    m_FvxROI->SetRectangle( m_FvRectangle );

    // FvxROIgď͈͑I_CAOo܂
    m_FvxROI->PutUsePoint( false );
    m_FvxROI->MakeROIDialog( m_FvxImage1, &lngOK);

    if ((lngOK == 1) && (m_FvxROI->GetCheckRectangle() == 1)) {
        m_FvxROI->GetRectangle( m_FvRectangle );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
        if ( m_FvRectangle->Getxe() < m_FvRectangle->Getxs() ) {
            dblTemp = m_FvRectangle->Getxs();
			m_FvRectangle->Putxs( m_FvRectangle->Getxe() );
            m_FvRectangle->Putxe( dblTemp );
		}
		if ( m_FvRectangle->Getye() < m_FvRectangle->Getys() ) {
            dblTemp = m_FvRectangle->Getys();
            m_FvRectangle->Putys( m_FvRectangle->Getye() );
            m_FvRectangle->Putye( dblTemp );
		}
	}

}

void CGrayFilterDlg::OnBnClickedSaveimage()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CFileDialog Dlg( FALSE, _T("bmp"), _T("*.bmp"), OFN_FILEMUSTEXIST, _T("Bmpt@C(*.bmp)|*.bmp|S(*.*)|*.*||"));

	CString strFileName;

	if (IDOK == Dlg.DoModal())
	{
		m_FvxFileAccess->FilePath = (_bstr_t)Dlg.GetPathName();

		try
		{
			m_FvxFileAccess->SaveBitmap(m_FvxImage1);
		} catch (long &err) {
			m_FvxFileAccess->GetErrReport(&err);
			CString errMsg;
			errMsg = "݂Ɏs܂BErrCode= %ld",err;
			::AfxMessageBox( errMsg);
			return;
		}

	}
}

void CGrayFilterDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);
	// TODO: ɃbZ[W nh R[hǉ܂B
	if (IsIconic() == 0 ) {

		if ( m_FvxDisplayEx != NULL ){

			CWnd *pwnd;
			CRect rect;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );

		}
	}
}
